/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -i configurationtype.h -i sigmodelstype.h -i vendormodelstype.h -a adaptor dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */

#include "adaptor.h"
#include <QtCore/QMetaObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>

/*
 * Implementation of adaptor class Element1Adaptor
 */

Element1Adaptor::Element1Adaptor(QObject *parent)
    : QDBusAbstractAdaptor(parent)
{
    // constructor
    setAutoRelaySignals(true);
}

Element1Adaptor::~Element1Adaptor()
{
    // destructor
}

uchar Element1Adaptor::index() const
{
    // get the value of property Index
    return qvariant_cast< uchar >(parent()->property("Index"));
}

ushort Element1Adaptor::location() const
{
    // get the value of property Location
    return qvariant_cast< ushort >(parent()->property("Location"));
}

Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType Element1Adaptor::models() const
{
    // get the value of property Models
    return qvariant_cast< Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType >(parent()->property("Models"));
}

Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType Element1Adaptor::vendorModels() const
{
    // get the value of property VendorModels
    return qvariant_cast< Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType >(parent()->property("VendorModels"));
}

void Element1Adaptor::DevKeyMessageReceived(ushort source, bool remote, ushort net_index, const QByteArray &data)
{
    // handle method call org.bluez.mesh.Element1.DevKeyMessageReceived
    QMetaObject::invokeMethod(parent(), "DevKeyMessageReceived", Q_ARG(ushort, source), Q_ARG(bool, remote), Q_ARG(ushort, net_index), Q_ARG(QByteArray, data));
}

void Element1Adaptor::MessageReceived(ushort source, ushort key_index, const QDBusVariant &destination, const QByteArray &data)
{
    // handle method call org.bluez.mesh.Element1.MessageReceived
    QMetaObject::invokeMethod(parent(), "MessageReceived", Q_ARG(ushort, source), Q_ARG(ushort, key_index), Q_ARG(QDBusVariant, destination), Q_ARG(QByteArray, data));
}

void Element1Adaptor::UpdateModelConfiguration(ushort model_id, Oscl::Qt::DBus::BlueZ::Mesh::Element1::ConfigurationType config)
{
    // handle method call org.bluez.mesh.Element1.UpdateModelConfiguration
    QMetaObject::invokeMethod(parent(), "UpdateModelConfiguration", Q_ARG(ushort, model_id), Q_ARG(Oscl::Qt::DBus::BlueZ::Mesh::Element1::ConfigurationType, config));
}

